/*
 * TCSS 305Winter 2014
 * Assignment 6b-Tetris
 */

package view;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JButton;

/**
 * This class creates a key listener for the pause key so that you can still pause the game 
 * with the 'P' key when the game is paused.
 * 
 * @author Brian Dennis
 * @version 13 March 2014
 */
public class PauseListener extends KeyAdapter implements PropertyChangeListener {

    /** The initial key binding value of the pause key. */
    private static final int PAUSE_KEY = 80;
    
    /** The JButton that lets you pause the game when clicked. */
    private final JButton myPause;
   
    /** The pause key value that can be changed to a new value. */
    private int myPauseKey = PAUSE_KEY;
    
    /**
     * The constructor that takes in the JButton needing to be paused. 
     * 
     * @param thePause the pause JButton
     */
    public PauseListener(final JButton thePause) {
        
        super();
        myPause = thePause;
    }
    /**
     * Handles a key being typed.
     * 
     * @param theEvent The KeyEvent generated by the key.
     * {@inheritDoc}
     */
    @Override
    public void keyPressed(final KeyEvent theEvent) {
        
        if (theEvent.getKeyCode() == myPauseKey) {
            
            myPause.doClick();
        }
    }
    
    /**
     * Handles the property changes when user changes the controls.
     * 
     * {@inheritDoc}
     */
    @Override
    public void propertyChange(final PropertyChangeEvent theEvent) {
        
        if ("P".equals(theEvent.getPropertyName())) {

            myPauseKey = (int) theEvent.getNewValue();   
        }
    }
}